package dev.pfaff.glass.apple.gcd;

/**
 * Quality-of-service classes that specify the priorities for executing tasks.
 *
 * @see <a href="https://developer.apple.com/documentation/dispatch/dispatchqos/qosclass">https://developer.apple.com/documentation/dispatch/dispatchqos/qosclass</a>
 */
public enum QoSClass {
	USER_INTERACTIVE(0x21L),
	USER_INITIATED(0x19L),
	DEFAULT(0x15L),
	UTILITY(0x11L),
	BACKGROUND(0x09L),
	MAINTENANCE(0x05L),
	UNSPECIFIED(0x00L);

	public final long value;

	QoSClass(long value) {
		this.value = value;
	}
}
