package dev.pfaff.glass.glfw;

public enum WindowHint {
	FOCUSED(0x00020001),
	ICONIFIED(0x00020002),
	RESIZABLE(0x00020003),
	VISIBLE(0x00020004),
	DECORATED(0x00020005),
	AUTO_ICONIFY(0x00020006),
	FLOATING(0x00020007),
	MAXIMIZED(0x00020008),
	CENTER_CURSOR(0x00020009),
	TRANSPARENT_FRAMEBUFFER(0x0002000A),
	HOVERED(0x0002000B),
	FOCUS_ON_SHOW(0x0002000C),
	CLIENT_API(0x00022001),
	CONTEXT_VERSION_MAJOR(0x00022002),
	CONTEXT_VERSION_MINOR(0x00022003),
	CONTEXT_REVISION(0x00022004),
	CONTEXT_ROBUSTNESS(0x00022005),
	OPENGL_FORWARD_COMPAT(0x00022006),
	CONTEXT_DEBUG(0x00022007),
	OPENGL_PROFILE(0x00022008),
	CONTEXT_RELEASE_BEHAVIOR(0x00022009),
	CONTEXT_NO_ERROR(0x0002200a),
	CONTEXT_CREATION_API(0x0002200b),
	SCALE_TO_MONITOR(0x0002200c),
	SCALE_FRAMEBUFFER(0x0002200d),
	/**
	 * Alias for {@link #SCALE_FRAMEBUFFER}.
	 */
	@Deprecated
	COCOA_RETINA_FRAMEBUFFER(0x00023001),
	COCOA_FRAME_NAME(0x00023002),
	COCOA_GRAPHICS_SWITCHING(0x00023003),
	X11_CLASS_NAME(0x00024001),
	X11_INSTANCE_NAME(0x00024002),
	WIN32_KEYBOARD_MENU(0x00025001),
	WIN32_SHOWDEFAULT(0x00025002),
	WAYLAND_APP_ID(0x00026001),

	SAMPLES(0x0002100D),

	/**
	 * Specifies whether the framebuffer should be double buffered. You nearly always want to use double buffering.
	 * This is a hard constraint. Possible values are GLFW_TRUE and GLFW_FALSE.
	 */
	DOUBLEBUFFER(0x00021010);

	private final int value;

	WindowHint(int value) {
		this.value = value;
	}

	public final int value() {
		return this.value;
	}
}
