package dev.pfaff.glass.opengl.enums;

import java.util.List;

import dev.pfaff.glass.opengl.GLEnum;

import static java.util.FormatProcessor.FMT;

public enum GLAccumOp implements GLEnum {
	ACCUM(0x100),
	LOAD(0x101),
	RETURN(0x102),
	MULT(0x103),
	ADD(0x104);
	
	private final int glEnum;

	GLAccumOp(int glEnum) {
		this.glEnum = glEnum;
	}

	public static final List<GLAccumOp> VALUES = List.of(values());

	@Override
	public int glEnum() {
		return glEnum;
	}

	/**
	 * Returns the enum constant corresponding to the provided raw value.
	 *
	 * @throws IllegalArgumentException if the provided raw value does not exist in this enum group.
	 */
	public static GLAccumOp fromGLEnum(int glEnum) {
		return switch (glEnum) {
			case 0x100 -> ACCUM;
			case 0x101 -> LOAD;
			case 0x102 -> RETURN;
			case 0x103 -> MULT;
			case 0x104 -> ADD;
			default -> throw RawGLEnum.newUnrecognizedValueError(glEnum, "GLAccumOp");
		};
	}
}