package dev.pfaff.glass.opengl.enums;

import java.util.List;

import dev.pfaff.glass.opengl.GLEnum;

import static java.util.FormatProcessor.FMT;

public enum GLAlphaFunction implements GLEnum {
	NEVER(0x200),
	LESS(0x201),
	EQUAL(0x202),
	LEQUAL(0x203),
	GREATER(0x204),
	NOTEQUAL(0x205),
	GEQUAL(0x206),
	ALWAYS(0x207);
	
	private final int glEnum;

	GLAlphaFunction(int glEnum) {
		this.glEnum = glEnum;
	}

	public static final List<GLAlphaFunction> VALUES = List.of(values());

	@Override
	public int glEnum() {
		return glEnum;
	}

	/**
	 * Returns the enum constant corresponding to the provided raw value.
	 *
	 * @throws IllegalArgumentException if the provided raw value does not exist in this enum group.
	 */
	public static GLAlphaFunction fromGLEnum(int glEnum) {
		return switch (glEnum) {
			case 0x200 -> NEVER;
			case 0x201 -> LESS;
			case 0x202 -> EQUAL;
			case 0x203 -> LEQUAL;
			case 0x204 -> GREATER;
			case 0x205 -> NOTEQUAL;
			case 0x206 -> GEQUAL;
			case 0x207 -> ALWAYS;
			default -> throw RawGLEnum.newUnrecognizedValueError(glEnum, "GLAlphaFunction");
		};
	}
}