package dev.pfaff.glass.opengl.enums;

import java.util.List;

import dev.pfaff.glass.opengl.GLEnum;

import static java.util.FormatProcessor.FMT;

public enum GLBlendEquationModeEXT implements GLEnum {
	FUNC_ADD(0x8006),
	MIN(0x8007),
	MAX(0x8008),
	FUNC_SUBTRACT(0x800a),
	FUNC_REVERSE_SUBTRACT(0x800b),
	ALPHA_MIN_SGIX(0x8320),
	ALPHA_MAX_SGIX(0x8321);
	
	private final int glEnum;

	GLBlendEquationModeEXT(int glEnum) {
		this.glEnum = glEnum;
	}

	public static final List<GLBlendEquationModeEXT> VALUES = List.of(values());

	@Override
	public int glEnum() {
		return glEnum;
	}

	/**
	 * Returns the enum constant corresponding to the provided raw value.
	 *
	 * @throws IllegalArgumentException if the provided raw value does not exist in this enum group.
	 */
	public static GLBlendEquationModeEXT fromGLEnum(int glEnum) {
		return switch (glEnum) {
			case 0x8006 -> FUNC_ADD;
			case 0x8007 -> MIN;
			case 0x8008 -> MAX;
			case 0x800a -> FUNC_SUBTRACT;
			case 0x800b -> FUNC_REVERSE_SUBTRACT;
			case 0x8320 -> ALPHA_MIN_SGIX;
			case 0x8321 -> ALPHA_MAX_SGIX;
			default -> throw RawGLEnum.newUnrecognizedValueError(glEnum, "GLBlendEquationModeEXT");
		};
	}
}