package dev.pfaff.glass.opengl.enums;

import java.util.List;

import dev.pfaff.glass.opengl.GLEnum;

import static java.util.FormatProcessor.FMT;

public enum GLBufferBitQCOM implements GLEnum {
	COLOR_BUFFER_BIT0_QCOM(0x1),
	COLOR_BUFFER_BIT1_QCOM(0x2),
	COLOR_BUFFER_BIT2_QCOM(0x4),
	COLOR_BUFFER_BIT3_QCOM(0x8),
	COLOR_BUFFER_BIT4_QCOM(0x10),
	COLOR_BUFFER_BIT5_QCOM(0x20),
	COLOR_BUFFER_BIT6_QCOM(0x40),
	COLOR_BUFFER_BIT7_QCOM(0x80),
	DEPTH_BUFFER_BIT0_QCOM(0x100),
	DEPTH_BUFFER_BIT1_QCOM(0x200),
	DEPTH_BUFFER_BIT2_QCOM(0x400),
	DEPTH_BUFFER_BIT3_QCOM(0x800),
	DEPTH_BUFFER_BIT4_QCOM(0x1000),
	DEPTH_BUFFER_BIT5_QCOM(0x2000),
	DEPTH_BUFFER_BIT6_QCOM(0x4000),
	DEPTH_BUFFER_BIT7_QCOM(0x8000),
	STENCIL_BUFFER_BIT0_QCOM(0x10000),
	STENCIL_BUFFER_BIT1_QCOM(0x20000),
	STENCIL_BUFFER_BIT2_QCOM(0x40000),
	STENCIL_BUFFER_BIT3_QCOM(0x80000),
	STENCIL_BUFFER_BIT4_QCOM(0x100000),
	STENCIL_BUFFER_BIT5_QCOM(0x200000),
	STENCIL_BUFFER_BIT6_QCOM(0x400000),
	STENCIL_BUFFER_BIT7_QCOM(0x800000),
	MULTISAMPLE_BUFFER_BIT0_QCOM(0x1000000),
	MULTISAMPLE_BUFFER_BIT1_QCOM(0x2000000),
	MULTISAMPLE_BUFFER_BIT2_QCOM(0x4000000),
	MULTISAMPLE_BUFFER_BIT3_QCOM(0x8000000),
	MULTISAMPLE_BUFFER_BIT4_QCOM(0x10000000),
	MULTISAMPLE_BUFFER_BIT5_QCOM(0x20000000),
	MULTISAMPLE_BUFFER_BIT6_QCOM(0x40000000),
	MULTISAMPLE_BUFFER_BIT7_QCOM(0x80000000);
	
	private final int glEnum;

	GLBufferBitQCOM(int glEnum) {
		this.glEnum = glEnum;
	}

	public static final List<GLBufferBitQCOM> VALUES = List.of(values());

	@Override
	public int glEnum() {
		return glEnum;
	}

	/**
	 * Returns the enum constant corresponding to the provided raw value.
	 *
	 * @throws IllegalArgumentException if the provided raw value does not exist in this enum group.
	 */
	public static GLBufferBitQCOM fromGLEnum(int glEnum) {
		return switch (glEnum) {
			case 0x1 -> COLOR_BUFFER_BIT0_QCOM;
			case 0x2 -> COLOR_BUFFER_BIT1_QCOM;
			case 0x4 -> COLOR_BUFFER_BIT2_QCOM;
			case 0x8 -> COLOR_BUFFER_BIT3_QCOM;
			case 0x10 -> COLOR_BUFFER_BIT4_QCOM;
			case 0x20 -> COLOR_BUFFER_BIT5_QCOM;
			case 0x40 -> COLOR_BUFFER_BIT6_QCOM;
			case 0x80 -> COLOR_BUFFER_BIT7_QCOM;
			case 0x100 -> DEPTH_BUFFER_BIT0_QCOM;
			case 0x200 -> DEPTH_BUFFER_BIT1_QCOM;
			case 0x400 -> DEPTH_BUFFER_BIT2_QCOM;
			case 0x800 -> DEPTH_BUFFER_BIT3_QCOM;
			case 0x1000 -> DEPTH_BUFFER_BIT4_QCOM;
			case 0x2000 -> DEPTH_BUFFER_BIT5_QCOM;
			case 0x4000 -> DEPTH_BUFFER_BIT6_QCOM;
			case 0x8000 -> DEPTH_BUFFER_BIT7_QCOM;
			case 0x10000 -> STENCIL_BUFFER_BIT0_QCOM;
			case 0x20000 -> STENCIL_BUFFER_BIT1_QCOM;
			case 0x40000 -> STENCIL_BUFFER_BIT2_QCOM;
			case 0x80000 -> STENCIL_BUFFER_BIT3_QCOM;
			case 0x100000 -> STENCIL_BUFFER_BIT4_QCOM;
			case 0x200000 -> STENCIL_BUFFER_BIT5_QCOM;
			case 0x400000 -> STENCIL_BUFFER_BIT6_QCOM;
			case 0x800000 -> STENCIL_BUFFER_BIT7_QCOM;
			case 0x1000000 -> MULTISAMPLE_BUFFER_BIT0_QCOM;
			case 0x2000000 -> MULTISAMPLE_BUFFER_BIT1_QCOM;
			case 0x4000000 -> MULTISAMPLE_BUFFER_BIT2_QCOM;
			case 0x8000000 -> MULTISAMPLE_BUFFER_BIT3_QCOM;
			case 0x10000000 -> MULTISAMPLE_BUFFER_BIT4_QCOM;
			case 0x20000000 -> MULTISAMPLE_BUFFER_BIT5_QCOM;
			case 0x40000000 -> MULTISAMPLE_BUFFER_BIT6_QCOM;
			case 0x80000000 -> MULTISAMPLE_BUFFER_BIT7_QCOM;
			default -> throw RawGLEnum.newUnrecognizedValueError(glEnum, "GLBufferBitQCOM");
		};
	}
}