package dev.pfaff.glass.opengl.enums;

import java.util.List;

import dev.pfaff.glass.opengl.GLEnum;

import static java.util.FormatProcessor.FMT;

public enum GLClientAttribMask implements GLEnum {
	CLIENT_PIXEL_STORE_BIT(0x1),
	CLIENT_VERTEX_ARRAY_BIT(0x2),
	CLIENT_ALL_ATTRIB_BITS(0xffffffff);
	
	private final int glEnum;

	GLClientAttribMask(int glEnum) {
		this.glEnum = glEnum;
	}

	public static final List<GLClientAttribMask> VALUES = List.of(values());

	@Override
	public int glEnum() {
		return glEnum;
	}

	/**
	 * Returns the enum constant corresponding to the provided raw value.
	 *
	 * @throws IllegalArgumentException if the provided raw value does not exist in this enum group.
	 */
	public static GLClientAttribMask fromGLEnum(int glEnum) {
		return switch (glEnum) {
			case 0x1 -> CLIENT_PIXEL_STORE_BIT;
			case 0x2 -> CLIENT_VERTEX_ARRAY_BIT;
			case 0xffffffff -> CLIENT_ALL_ATTRIB_BITS;
			default -> throw RawGLEnum.newUnrecognizedValueError(glEnum, "GLClientAttribMask");
		};
	}
}