package dev.pfaff.glass.opengl.enums;

import java.util.List;

import dev.pfaff.glass.opengl.GLEnum;

import static java.util.FormatProcessor.FMT;

public enum GLCombinerBiasNV implements GLEnum {
	NONE(0x0),
	BIAS_BY_NEGATIVE_ONE_HALF_NV(0x8541);
	
	private final int glEnum;

	GLCombinerBiasNV(int glEnum) {
		this.glEnum = glEnum;
	}

	public static final List<GLCombinerBiasNV> VALUES = List.of(values());

	@Override
	public int glEnum() {
		return glEnum;
	}

	/**
	 * Returns the enum constant corresponding to the provided raw value.
	 *
	 * @throws IllegalArgumentException if the provided raw value does not exist in this enum group.
	 */
	public static GLCombinerBiasNV fromGLEnum(int glEnum) {
		return switch (glEnum) {
			case 0x0 -> NONE;
			case 0x8541 -> BIAS_BY_NEGATIVE_ONE_HALF_NV;
			default -> throw RawGLEnum.newUnrecognizedValueError(glEnum, "GLCombinerBiasNV");
		};
	}
}