package dev.pfaff.glass.opengl.enums;

import java.util.List;

import dev.pfaff.glass.opengl.GLEnum;

import static java.util.FormatProcessor.FMT;

public enum GLCombinerPortionNV implements GLEnum {
	ALPHA(0x1906),
	RGB(0x1907);
	
	private final int glEnum;

	GLCombinerPortionNV(int glEnum) {
		this.glEnum = glEnum;
	}

	public static final List<GLCombinerPortionNV> VALUES = List.of(values());

	@Override
	public int glEnum() {
		return glEnum;
	}

	/**
	 * Returns the enum constant corresponding to the provided raw value.
	 *
	 * @throws IllegalArgumentException if the provided raw value does not exist in this enum group.
	 */
	public static GLCombinerPortionNV fromGLEnum(int glEnum) {
		return switch (glEnum) {
			case 0x1906 -> ALPHA;
			case 0x1907 -> RGB;
			default -> throw RawGLEnum.newUnrecognizedValueError(glEnum, "GLCombinerPortionNV");
		};
	}
}