package dev.pfaff.glass.opengl.enums;

import java.util.List;

import dev.pfaff.glass.opengl.GLEnum;

import static java.util.FormatProcessor.FMT;

public enum GLCommandOpcodesNV implements GLEnum {
	TERMINATE_SEQUENCE_COMMAND_NV(0x0),
	NOP_COMMAND_NV(0x1),
	DRAW_ELEMENTS_COMMAND_NV(0x2),
	DRAW_ARRAYS_COMMAND_NV(0x3),
	DRAW_ELEMENTS_STRIP_COMMAND_NV(0x4),
	DRAW_ARRAYS_STRIP_COMMAND_NV(0x5),
	DRAW_ELEMENTS_INSTANCED_COMMAND_NV(0x6),
	DRAW_ARRAYS_INSTANCED_COMMAND_NV(0x7),
	ELEMENT_ADDRESS_COMMAND_NV(0x8),
	ATTRIBUTE_ADDRESS_COMMAND_NV(0x9),
	UNIFORM_ADDRESS_COMMAND_NV(0xa),
	BLEND_COLOR_COMMAND_NV(0xb),
	STENCIL_REF_COMMAND_NV(0xc),
	LINE_WIDTH_COMMAND_NV(0xd),
	POLYGON_OFFSET_COMMAND_NV(0xe),
	ALPHA_REF_COMMAND_NV(0xf),
	VIEWPORT_COMMAND_NV(0x10),
	SCISSOR_COMMAND_NV(0x11),
	FRONT_FACE_COMMAND_NV(0x12);
	
	private final int glEnum;

	GLCommandOpcodesNV(int glEnum) {
		this.glEnum = glEnum;
	}

	public static final List<GLCommandOpcodesNV> VALUES = List.of(values());

	@Override
	public int glEnum() {
		return glEnum;
	}

	/**
	 * Returns the enum constant corresponding to the provided raw value.
	 *
	 * @throws IllegalArgumentException if the provided raw value does not exist in this enum group.
	 */
	public static GLCommandOpcodesNV fromGLEnum(int glEnum) {
		return switch (glEnum) {
			case 0x0 -> TERMINATE_SEQUENCE_COMMAND_NV;
			case 0x1 -> NOP_COMMAND_NV;
			case 0x2 -> DRAW_ELEMENTS_COMMAND_NV;
			case 0x3 -> DRAW_ARRAYS_COMMAND_NV;
			case 0x4 -> DRAW_ELEMENTS_STRIP_COMMAND_NV;
			case 0x5 -> DRAW_ARRAYS_STRIP_COMMAND_NV;
			case 0x6 -> DRAW_ELEMENTS_INSTANCED_COMMAND_NV;
			case 0x7 -> DRAW_ARRAYS_INSTANCED_COMMAND_NV;
			case 0x8 -> ELEMENT_ADDRESS_COMMAND_NV;
			case 0x9 -> ATTRIBUTE_ADDRESS_COMMAND_NV;
			case 0xa -> UNIFORM_ADDRESS_COMMAND_NV;
			case 0xb -> BLEND_COLOR_COMMAND_NV;
			case 0xc -> STENCIL_REF_COMMAND_NV;
			case 0xd -> LINE_WIDTH_COMMAND_NV;
			case 0xe -> POLYGON_OFFSET_COMMAND_NV;
			case 0xf -> ALPHA_REF_COMMAND_NV;
			case 0x10 -> VIEWPORT_COMMAND_NV;
			case 0x11 -> SCISSOR_COMMAND_NV;
			case 0x12 -> FRONT_FACE_COMMAND_NV;
			default -> throw RawGLEnum.newUnrecognizedValueError(glEnum, "GLCommandOpcodesNV");
		};
	}
}