package dev.pfaff.glass.opengl.enums;

import java.util.List;

import dev.pfaff.glass.opengl.GLEnum;

import static java.util.FormatProcessor.FMT;

public enum GLCullParameterEXT implements GLEnum {
	CULL_VERTEX_EYE_POSITION_EXT(0x81ab),
	CULL_VERTEX_OBJECT_POSITION_EXT(0x81ac);
	
	private final int glEnum;

	GLCullParameterEXT(int glEnum) {
		this.glEnum = glEnum;
	}

	public static final List<GLCullParameterEXT> VALUES = List.of(values());

	@Override
	public int glEnum() {
		return glEnum;
	}

	/**
	 * Returns the enum constant corresponding to the provided raw value.
	 *
	 * @throws IllegalArgumentException if the provided raw value does not exist in this enum group.
	 */
	public static GLCullParameterEXT fromGLEnum(int glEnum) {
		return switch (glEnum) {
			case 0x81ab -> CULL_VERTEX_EYE_POSITION_EXT;
			case 0x81ac -> CULL_VERTEX_OBJECT_POSITION_EXT;
			default -> throw RawGLEnum.newUnrecognizedValueError(glEnum, "GLCullParameterEXT");
		};
	}
}