package dev.pfaff.glass.opengl.enums;

import java.util.List;

import dev.pfaff.glass.opengl.GLEnum;

import static java.util.FormatProcessor.FMT;

public enum GLDebugSource implements GLEnum {
	DONT_CARE(0x1100),
	DEBUG_SOURCE_API(0x8246),
	DEBUG_SOURCE_WINDOW_SYSTEM(0x8247),
	DEBUG_SOURCE_SHADER_COMPILER(0x8248),
	DEBUG_SOURCE_THIRD_PARTY(0x8249),
	DEBUG_SOURCE_APPLICATION(0x824a),
	DEBUG_SOURCE_OTHER(0x824b);
	
	private final int glEnum;

	GLDebugSource(int glEnum) {
		this.glEnum = glEnum;
	}

	public static final List<GLDebugSource> VALUES = List.of(values());

	@Override
	public int glEnum() {
		return glEnum;
	}

	/**
	 * Returns the enum constant corresponding to the provided raw value.
	 *
	 * @throws IllegalArgumentException if the provided raw value does not exist in this enum group.
	 */
	public static GLDebugSource fromGLEnum(int glEnum) {
		return switch (glEnum) {
			case 0x1100 -> DONT_CARE;
			case 0x8246 -> DEBUG_SOURCE_API;
			case 0x8247 -> DEBUG_SOURCE_WINDOW_SYSTEM;
			case 0x8248 -> DEBUG_SOURCE_SHADER_COMPILER;
			case 0x8249 -> DEBUG_SOURCE_THIRD_PARTY;
			case 0x824a -> DEBUG_SOURCE_APPLICATION;
			case 0x824b -> DEBUG_SOURCE_OTHER;
			default -> throw RawGLEnum.newUnrecognizedValueError(glEnum, "GLDebugSource");
		};
	}
}