package dev.pfaff.glass.opengl.enums;

import java.util.List;

import dev.pfaff.glass.opengl.GLEnum;

import static java.util.FormatProcessor.FMT;

public enum GLEnableCap implements GLEnum {
	POINT_SMOOTH(0xb10),
	LINE_SMOOTH(0xb20),
	LINE_STIPPLE(0xb24),
	POLYGON_SMOOTH(0xb41),
	POLYGON_STIPPLE(0xb42),
	CULL_FACE(0xb44),
	LIGHTING(0xb50),
	COLOR_MATERIAL(0xb57),
	FOG(0xb60),
	DEPTH_TEST(0xb71),
	STENCIL_TEST(0xb90),
	NORMALIZE(0xba1),
	ALPHA_TEST(0xbc0),
	DITHER(0xbd0),
	BLEND(0xbe2),
	INDEX_LOGIC_OP(0xbf1),
	COLOR_LOGIC_OP(0xbf2),
	SCISSOR_TEST(0xc11),
	TEXTURE_GEN_S(0xc60),
	TEXTURE_GEN_T(0xc61),
	TEXTURE_GEN_R(0xc62),
	TEXTURE_GEN_Q(0xc63),
	AUTO_NORMAL(0xd80),
	MAP1_COLOR_4(0xd90),
	MAP1_INDEX(0xd91),
	MAP1_NORMAL(0xd92),
	MAP1_TEXTURE_COORD_1(0xd93),
	MAP1_TEXTURE_COORD_2(0xd94),
	MAP1_TEXTURE_COORD_3(0xd95),
	MAP1_TEXTURE_COORD_4(0xd96),
	MAP1_VERTEX_3(0xd97),
	MAP1_VERTEX_4(0xd98),
	MAP2_COLOR_4(0xdb0),
	MAP2_INDEX(0xdb1),
	MAP2_NORMAL(0xdb2),
	MAP2_TEXTURE_COORD_1(0xdb3),
	MAP2_TEXTURE_COORD_2(0xdb4),
	MAP2_TEXTURE_COORD_3(0xdb5),
	MAP2_TEXTURE_COORD_4(0xdb6),
	MAP2_VERTEX_3(0xdb7),
	MAP2_VERTEX_4(0xdb8),
	TEXTURE_1D(0xde0),
	TEXTURE_2D(0xde1),
	POLYGON_OFFSET_POINT(0x2a01),
	POLYGON_OFFSET_LINE(0x2a02),
	CLIP_PLANE0(0x3000),
	CLIP_PLANE1(0x3001),
	CLIP_PLANE2(0x3002),
	CLIP_PLANE3(0x3003),
	CLIP_PLANE4(0x3004),
	CLIP_PLANE5(0x3005),
	CLIP_DISTANCE6(0x3006),
	CLIP_DISTANCE7(0x3007),
	LIGHT0(0x4000),
	LIGHT1(0x4001),
	LIGHT2(0x4002),
	LIGHT3(0x4003),
	LIGHT4(0x4004),
	LIGHT5(0x4005),
	LIGHT6(0x4006),
	LIGHT7(0x4007),
	CONVOLUTION_1D(0x8010),
	CONVOLUTION_2D(0x8011),
	SEPARABLE_2D(0x8012),
	HISTOGRAM(0x8024),
	MINMAX(0x802e),
	POLYGON_OFFSET_FILL(0x8037),
	RESCALE_NORMAL(0x803a),
	TEXTURE_3D(0x806f),
	VERTEX_ARRAY(0x8074),
	NORMAL_ARRAY(0x8075),
	COLOR_ARRAY(0x8076),
	INDEX_ARRAY(0x8077),
	TEXTURE_COORD_ARRAY(0x8078),
	EDGE_FLAG_ARRAY(0x8079),
	INTERLACE_SGIX(0x8094),
	MULTISAMPLE(0x809d),
	SAMPLE_ALPHA_TO_COVERAGE(0x809e),
	SAMPLE_ALPHA_TO_ONE(0x809f),
	SAMPLE_COVERAGE(0x80a0),
	TEXTURE_COLOR_TABLE_SGI(0x80bc),
	COLOR_TABLE(0x80d0),
	POST_CONVOLUTION_COLOR_TABLE(0x80d1),
	POST_COLOR_MATRIX_COLOR_TABLE(0x80d2),
	TEXTURE_4D_SGIS(0x8134),
	PIXEL_TEX_GEN_SGIX(0x8139),
	SPRITE_SGIX(0x8148),
	REFERENCE_PLANE_SGIX(0x817d),
	IR_INSTRUMENT1_SGIX(0x817f),
	CALLIGRAPHIC_FRAGMENT_SGIX(0x8183),
	FRAMEZOOM_SGIX(0x818b),
	FOG_OFFSET_SGIX(0x8198),
	SHARED_TEXTURE_PALETTE_EXT(0x81fb),
	DEBUG_OUTPUT_SYNCHRONOUS(0x8242),
	ASYNC_HISTOGRAM_SGIX(0x832c),
	PIXEL_TEXTURE_SGIS(0x8353),
	ASYNC_TEX_IMAGE_SGIX(0x835c),
	ASYNC_DRAW_PIXELS_SGIX(0x835d),
	ASYNC_READ_PIXELS_SGIX(0x835e),
	FRAGMENT_LIGHTING_SGIX(0x8400),
	FRAGMENT_COLOR_MATERIAL_SGIX(0x8401),
	FRAGMENT_LIGHT0_SGIX(0x840c),
	FRAGMENT_LIGHT1_SGIX(0x840d),
	FRAGMENT_LIGHT2_SGIX(0x840e),
	FRAGMENT_LIGHT3_SGIX(0x840f),
	FRAGMENT_LIGHT4_SGIX(0x8410),
	FRAGMENT_LIGHT5_SGIX(0x8411),
	FRAGMENT_LIGHT6_SGIX(0x8412),
	FRAGMENT_LIGHT7_SGIX(0x8413),
	TEXTURE_RECTANGLE(0x84f5),
	TEXTURE_CUBE_MAP(0x8513),
	PROGRAM_POINT_SIZE(0x8642),
	DEPTH_CLAMP(0x864f),
	TEXTURE_CUBE_MAP_SEAMLESS(0x884f),
	SAMPLE_SHADING(0x8c36),
	RASTERIZER_DISCARD(0x8c89),
	TEXTURE_GEN_STR_OES(0x8d60),
	PRIMITIVE_RESTART_FIXED_INDEX(0x8d69),
	FRAMEBUFFER_SRGB(0x8db9),
	SAMPLE_MASK(0x8e51),
	FETCH_PER_SAMPLE_ARM(0x8f65),
	PRIMITIVE_RESTART(0x8f9d),
	DEBUG_OUTPUT(0x92e0),
	SHADING_RATE_IMAGE_PER_PRIMITIVE_NV(0x95b1),
	FRAMEBUFFER_FETCH_NONCOHERENT_QCOM(0x96a2),
	SHADING_RATE_PRESERVE_ASPECT_RATIO_QCOM(0x96a5);
	
	private final int glEnum;

	GLEnableCap(int glEnum) {
		this.glEnum = glEnum;
	}

	public static final List<GLEnableCap> VALUES = List.of(values());

	@Override
	public int glEnum() {
		return glEnum;
	}

	/**
	 * Returns the enum constant corresponding to the provided raw value.
	 *
	 * @throws IllegalArgumentException if the provided raw value does not exist in this enum group.
	 */
	public static GLEnableCap fromGLEnum(int glEnum) {
		return switch (glEnum) {
			case 0xb10 -> POINT_SMOOTH;
			case 0xb20 -> LINE_SMOOTH;
			case 0xb24 -> LINE_STIPPLE;
			case 0xb41 -> POLYGON_SMOOTH;
			case 0xb42 -> POLYGON_STIPPLE;
			case 0xb44 -> CULL_FACE;
			case 0xb50 -> LIGHTING;
			case 0xb57 -> COLOR_MATERIAL;
			case 0xb60 -> FOG;
			case 0xb71 -> DEPTH_TEST;
			case 0xb90 -> STENCIL_TEST;
			case 0xba1 -> NORMALIZE;
			case 0xbc0 -> ALPHA_TEST;
			case 0xbd0 -> DITHER;
			case 0xbe2 -> BLEND;
			case 0xbf1 -> INDEX_LOGIC_OP;
			case 0xbf2 -> COLOR_LOGIC_OP;
			case 0xc11 -> SCISSOR_TEST;
			case 0xc60 -> TEXTURE_GEN_S;
			case 0xc61 -> TEXTURE_GEN_T;
			case 0xc62 -> TEXTURE_GEN_R;
			case 0xc63 -> TEXTURE_GEN_Q;
			case 0xd80 -> AUTO_NORMAL;
			case 0xd90 -> MAP1_COLOR_4;
			case 0xd91 -> MAP1_INDEX;
			case 0xd92 -> MAP1_NORMAL;
			case 0xd93 -> MAP1_TEXTURE_COORD_1;
			case 0xd94 -> MAP1_TEXTURE_COORD_2;
			case 0xd95 -> MAP1_TEXTURE_COORD_3;
			case 0xd96 -> MAP1_TEXTURE_COORD_4;
			case 0xd97 -> MAP1_VERTEX_3;
			case 0xd98 -> MAP1_VERTEX_4;
			case 0xdb0 -> MAP2_COLOR_4;
			case 0xdb1 -> MAP2_INDEX;
			case 0xdb2 -> MAP2_NORMAL;
			case 0xdb3 -> MAP2_TEXTURE_COORD_1;
			case 0xdb4 -> MAP2_TEXTURE_COORD_2;
			case 0xdb5 -> MAP2_TEXTURE_COORD_3;
			case 0xdb6 -> MAP2_TEXTURE_COORD_4;
			case 0xdb7 -> MAP2_VERTEX_3;
			case 0xdb8 -> MAP2_VERTEX_4;
			case 0xde0 -> TEXTURE_1D;
			case 0xde1 -> TEXTURE_2D;
			case 0x2a01 -> POLYGON_OFFSET_POINT;
			case 0x2a02 -> POLYGON_OFFSET_LINE;
			case 0x3000 -> CLIP_PLANE0;
			case 0x3001 -> CLIP_PLANE1;
			case 0x3002 -> CLIP_PLANE2;
			case 0x3003 -> CLIP_PLANE3;
			case 0x3004 -> CLIP_PLANE4;
			case 0x3005 -> CLIP_PLANE5;
			case 0x3006 -> CLIP_DISTANCE6;
			case 0x3007 -> CLIP_DISTANCE7;
			case 0x4000 -> LIGHT0;
			case 0x4001 -> LIGHT1;
			case 0x4002 -> LIGHT2;
			case 0x4003 -> LIGHT3;
			case 0x4004 -> LIGHT4;
			case 0x4005 -> LIGHT5;
			case 0x4006 -> LIGHT6;
			case 0x4007 -> LIGHT7;
			case 0x8010 -> CONVOLUTION_1D;
			case 0x8011 -> CONVOLUTION_2D;
			case 0x8012 -> SEPARABLE_2D;
			case 0x8024 -> HISTOGRAM;
			case 0x802e -> MINMAX;
			case 0x8037 -> POLYGON_OFFSET_FILL;
			case 0x803a -> RESCALE_NORMAL;
			case 0x806f -> TEXTURE_3D;
			case 0x8074 -> VERTEX_ARRAY;
			case 0x8075 -> NORMAL_ARRAY;
			case 0x8076 -> COLOR_ARRAY;
			case 0x8077 -> INDEX_ARRAY;
			case 0x8078 -> TEXTURE_COORD_ARRAY;
			case 0x8079 -> EDGE_FLAG_ARRAY;
			case 0x8094 -> INTERLACE_SGIX;
			case 0x809d -> MULTISAMPLE;
			case 0x809e -> SAMPLE_ALPHA_TO_COVERAGE;
			case 0x809f -> SAMPLE_ALPHA_TO_ONE;
			case 0x80a0 -> SAMPLE_COVERAGE;
			case 0x80bc -> TEXTURE_COLOR_TABLE_SGI;
			case 0x80d0 -> COLOR_TABLE;
			case 0x80d1 -> POST_CONVOLUTION_COLOR_TABLE;
			case 0x80d2 -> POST_COLOR_MATRIX_COLOR_TABLE;
			case 0x8134 -> TEXTURE_4D_SGIS;
			case 0x8139 -> PIXEL_TEX_GEN_SGIX;
			case 0x8148 -> SPRITE_SGIX;
			case 0x817d -> REFERENCE_PLANE_SGIX;
			case 0x817f -> IR_INSTRUMENT1_SGIX;
			case 0x8183 -> CALLIGRAPHIC_FRAGMENT_SGIX;
			case 0x818b -> FRAMEZOOM_SGIX;
			case 0x8198 -> FOG_OFFSET_SGIX;
			case 0x81fb -> SHARED_TEXTURE_PALETTE_EXT;
			case 0x8242 -> DEBUG_OUTPUT_SYNCHRONOUS;
			case 0x832c -> ASYNC_HISTOGRAM_SGIX;
			case 0x8353 -> PIXEL_TEXTURE_SGIS;
			case 0x835c -> ASYNC_TEX_IMAGE_SGIX;
			case 0x835d -> ASYNC_DRAW_PIXELS_SGIX;
			case 0x835e -> ASYNC_READ_PIXELS_SGIX;
			case 0x8400 -> FRAGMENT_LIGHTING_SGIX;
			case 0x8401 -> FRAGMENT_COLOR_MATERIAL_SGIX;
			case 0x840c -> FRAGMENT_LIGHT0_SGIX;
			case 0x840d -> FRAGMENT_LIGHT1_SGIX;
			case 0x840e -> FRAGMENT_LIGHT2_SGIX;
			case 0x840f -> FRAGMENT_LIGHT3_SGIX;
			case 0x8410 -> FRAGMENT_LIGHT4_SGIX;
			case 0x8411 -> FRAGMENT_LIGHT5_SGIX;
			case 0x8412 -> FRAGMENT_LIGHT6_SGIX;
			case 0x8413 -> FRAGMENT_LIGHT7_SGIX;
			case 0x84f5 -> TEXTURE_RECTANGLE;
			case 0x8513 -> TEXTURE_CUBE_MAP;
			case 0x8642 -> PROGRAM_POINT_SIZE;
			case 0x864f -> DEPTH_CLAMP;
			case 0x884f -> TEXTURE_CUBE_MAP_SEAMLESS;
			case 0x8c36 -> SAMPLE_SHADING;
			case 0x8c89 -> RASTERIZER_DISCARD;
			case 0x8d60 -> TEXTURE_GEN_STR_OES;
			case 0x8d69 -> PRIMITIVE_RESTART_FIXED_INDEX;
			case 0x8db9 -> FRAMEBUFFER_SRGB;
			case 0x8e51 -> SAMPLE_MASK;
			case 0x8f65 -> FETCH_PER_SAMPLE_ARM;
			case 0x8f9d -> PRIMITIVE_RESTART;
			case 0x92e0 -> DEBUG_OUTPUT;
			case 0x95b1 -> SHADING_RATE_IMAGE_PER_PRIMITIVE_NV;
			case 0x96a2 -> FRAMEBUFFER_FETCH_NONCOHERENT_QCOM;
			case 0x96a5 -> SHADING_RATE_PRESERVE_ASPECT_RATIO_QCOM;
			default -> throw RawGLEnum.newUnrecognizedValueError(glEnum, "GLEnableCap");
		};
	}
}