package dev.pfaff.glass.opengl.enums;

import java.util.List;

import dev.pfaff.glass.opengl.GLEnum;

import static java.util.FormatProcessor.FMT;

public enum GLFeedbackType implements GLEnum {
	_2D(0x600),
	_3D(0x601),
	_3D_COLOR(0x602),
	_3D_COLOR_TEXTURE(0x603),
	_4D_COLOR_TEXTURE(0x604);
	
	private final int glEnum;

	GLFeedbackType(int glEnum) {
		this.glEnum = glEnum;
	}

	public static final List<GLFeedbackType> VALUES = List.of(values());

	@Override
	public int glEnum() {
		return glEnum;
	}

	/**
	 * Returns the enum constant corresponding to the provided raw value.
	 *
	 * @throws IllegalArgumentException if the provided raw value does not exist in this enum group.
	 */
	public static GLFeedbackType fromGLEnum(int glEnum) {
		return switch (glEnum) {
			case 0x600 -> _2D;
			case 0x601 -> _3D;
			case 0x602 -> _3D_COLOR;
			case 0x603 -> _3D_COLOR_TEXTURE;
			case 0x604 -> _4D_COLOR_TEXTURE;
			default -> throw RawGLEnum.newUnrecognizedValueError(glEnum, "GLFeedbackType");
		};
	}
}