package dev.pfaff.glass.opengl.enums;

import java.util.List;

import dev.pfaff.glass.opengl.GLEnum;

import static java.util.FormatProcessor.FMT;

public enum GLFragmentShaderTextureSourceATI implements GLEnum {
	TEXTURE0(0x84c0),
	TEXTURE1(0x84c1),
	TEXTURE2(0x84c2),
	TEXTURE3(0x84c3),
	TEXTURE4(0x84c4),
	TEXTURE5(0x84c5),
	TEXTURE6(0x84c6),
	TEXTURE7(0x84c7),
	TEXTURE8(0x84c8),
	TEXTURE9(0x84c9),
	TEXTURE10(0x84ca),
	TEXTURE11(0x84cb),
	TEXTURE12(0x84cc),
	TEXTURE13(0x84cd),
	TEXTURE14(0x84ce),
	TEXTURE15(0x84cf),
	TEXTURE16(0x84d0),
	TEXTURE17(0x84d1),
	TEXTURE18(0x84d2),
	TEXTURE19(0x84d3),
	TEXTURE20(0x84d4),
	TEXTURE21(0x84d5),
	TEXTURE22(0x84d6),
	TEXTURE23(0x84d7),
	TEXTURE24(0x84d8),
	TEXTURE25(0x84d9),
	TEXTURE26(0x84da),
	TEXTURE27(0x84db),
	TEXTURE28(0x84dc),
	TEXTURE29(0x84dd),
	TEXTURE30(0x84de),
	TEXTURE31(0x84df),
	REG_0_ATI(0x8921),
	REG_1_ATI(0x8922),
	REG_2_ATI(0x8923),
	REG_3_ATI(0x8924),
	REG_4_ATI(0x8925),
	REG_5_ATI(0x8926),
	REG_6_ATI(0x8927),
	REG_7_ATI(0x8928),
	REG_8_ATI(0x8929),
	REG_9_ATI(0x892a),
	REG_10_ATI(0x892b),
	REG_11_ATI(0x892c),
	REG_12_ATI(0x892d),
	REG_13_ATI(0x892e),
	REG_14_ATI(0x892f),
	REG_15_ATI(0x8930),
	REG_16_ATI(0x8931),
	REG_17_ATI(0x8932),
	REG_18_ATI(0x8933),
	REG_19_ATI(0x8934),
	REG_20_ATI(0x8935),
	REG_21_ATI(0x8936),
	REG_22_ATI(0x8937),
	REG_23_ATI(0x8938),
	REG_24_ATI(0x8939),
	REG_25_ATI(0x893a),
	REG_26_ATI(0x893b),
	REG_27_ATI(0x893c),
	REG_28_ATI(0x893d),
	REG_29_ATI(0x893e),
	REG_30_ATI(0x893f),
	REG_31_ATI(0x8940);
	
	private final int glEnum;

	GLFragmentShaderTextureSourceATI(int glEnum) {
		this.glEnum = glEnum;
	}

	public static final List<GLFragmentShaderTextureSourceATI> VALUES = List.of(values());

	@Override
	public int glEnum() {
		return glEnum;
	}

	/**
	 * Returns the enum constant corresponding to the provided raw value.
	 *
	 * @throws IllegalArgumentException if the provided raw value does not exist in this enum group.
	 */
	public static GLFragmentShaderTextureSourceATI fromGLEnum(int glEnum) {
		return switch (glEnum) {
			case 0x84c0 -> TEXTURE0;
			case 0x84c1 -> TEXTURE1;
			case 0x84c2 -> TEXTURE2;
			case 0x84c3 -> TEXTURE3;
			case 0x84c4 -> TEXTURE4;
			case 0x84c5 -> TEXTURE5;
			case 0x84c6 -> TEXTURE6;
			case 0x84c7 -> TEXTURE7;
			case 0x84c8 -> TEXTURE8;
			case 0x84c9 -> TEXTURE9;
			case 0x84ca -> TEXTURE10;
			case 0x84cb -> TEXTURE11;
			case 0x84cc -> TEXTURE12;
			case 0x84cd -> TEXTURE13;
			case 0x84ce -> TEXTURE14;
			case 0x84cf -> TEXTURE15;
			case 0x84d0 -> TEXTURE16;
			case 0x84d1 -> TEXTURE17;
			case 0x84d2 -> TEXTURE18;
			case 0x84d3 -> TEXTURE19;
			case 0x84d4 -> TEXTURE20;
			case 0x84d5 -> TEXTURE21;
			case 0x84d6 -> TEXTURE22;
			case 0x84d7 -> TEXTURE23;
			case 0x84d8 -> TEXTURE24;
			case 0x84d9 -> TEXTURE25;
			case 0x84da -> TEXTURE26;
			case 0x84db -> TEXTURE27;
			case 0x84dc -> TEXTURE28;
			case 0x84dd -> TEXTURE29;
			case 0x84de -> TEXTURE30;
			case 0x84df -> TEXTURE31;
			case 0x8921 -> REG_0_ATI;
			case 0x8922 -> REG_1_ATI;
			case 0x8923 -> REG_2_ATI;
			case 0x8924 -> REG_3_ATI;
			case 0x8925 -> REG_4_ATI;
			case 0x8926 -> REG_5_ATI;
			case 0x8927 -> REG_6_ATI;
			case 0x8928 -> REG_7_ATI;
			case 0x8929 -> REG_8_ATI;
			case 0x892a -> REG_9_ATI;
			case 0x892b -> REG_10_ATI;
			case 0x892c -> REG_11_ATI;
			case 0x892d -> REG_12_ATI;
			case 0x892e -> REG_13_ATI;
			case 0x892f -> REG_14_ATI;
			case 0x8930 -> REG_15_ATI;
			case 0x8931 -> REG_16_ATI;
			case 0x8932 -> REG_17_ATI;
			case 0x8933 -> REG_18_ATI;
			case 0x8934 -> REG_19_ATI;
			case 0x8935 -> REG_20_ATI;
			case 0x8936 -> REG_21_ATI;
			case 0x8937 -> REG_22_ATI;
			case 0x8938 -> REG_23_ATI;
			case 0x8939 -> REG_24_ATI;
			case 0x893a -> REG_25_ATI;
			case 0x893b -> REG_26_ATI;
			case 0x893c -> REG_27_ATI;
			case 0x893d -> REG_28_ATI;
			case 0x893e -> REG_29_ATI;
			case 0x893f -> REG_30_ATI;
			case 0x8940 -> REG_31_ATI;
			default -> throw RawGLEnum.newUnrecognizedValueError(glEnum, "GLFragmentShaderTextureSourceATI");
		};
	}
}