package dev.pfaff.glass.opengl.enums;

import java.util.List;

import dev.pfaff.glass.opengl.GLEnum;

import static java.util.FormatProcessor.FMT;

public enum GLFramebufferAttachmentParameterName implements GLEnum {
	FRAMEBUFFER_ATTACHMENT_COLOR_ENCODING(0x8210),
	FRAMEBUFFER_ATTACHMENT_COMPONENT_TYPE(0x8211),
	FRAMEBUFFER_ATTACHMENT_RED_SIZE(0x8212),
	FRAMEBUFFER_ATTACHMENT_GREEN_SIZE(0x8213),
	FRAMEBUFFER_ATTACHMENT_BLUE_SIZE(0x8214),
	FRAMEBUFFER_ATTACHMENT_ALPHA_SIZE(0x8215),
	FRAMEBUFFER_ATTACHMENT_DEPTH_SIZE(0x8216),
	FRAMEBUFFER_ATTACHMENT_STENCIL_SIZE(0x8217),
	FRAMEBUFFER_ATTACHMENT_OBJECT_TYPE(0x8cd0),
	FRAMEBUFFER_ATTACHMENT_OBJECT_NAME(0x8cd1),
	FRAMEBUFFER_ATTACHMENT_TEXTURE_LEVEL(0x8cd2),
	FRAMEBUFFER_ATTACHMENT_TEXTURE_CUBE_MAP_FACE(0x8cd3),
	FRAMEBUFFER_ATTACHMENT_TEXTURE_3D_ZOFFSET_EXT(0x8cd4),
	FRAMEBUFFER_ATTACHMENT_TEXTURE_SAMPLES_EXT(0x8d6c),
	FRAMEBUFFER_ATTACHMENT_LAYERED(0x8da7),
	FRAMEBUFFER_ATTACHMENT_TEXTURE_SCALE_IMG(0x913f),
	FRAMEBUFFER_ATTACHMENT_TEXTURE_NUM_VIEWS_OVR(0x9630),
	FRAMEBUFFER_ATTACHMENT_TEXTURE_BASE_VIEW_INDEX_OVR(0x9632);
	
	private final int glEnum;

	GLFramebufferAttachmentParameterName(int glEnum) {
		this.glEnum = glEnum;
	}

	public static final List<GLFramebufferAttachmentParameterName> VALUES = List.of(values());

	@Override
	public int glEnum() {
		return glEnum;
	}

	/**
	 * Returns the enum constant corresponding to the provided raw value.
	 *
	 * @throws IllegalArgumentException if the provided raw value does not exist in this enum group.
	 */
	public static GLFramebufferAttachmentParameterName fromGLEnum(int glEnum) {
		return switch (glEnum) {
			case 0x8210 -> FRAMEBUFFER_ATTACHMENT_COLOR_ENCODING;
			case 0x8211 -> FRAMEBUFFER_ATTACHMENT_COMPONENT_TYPE;
			case 0x8212 -> FRAMEBUFFER_ATTACHMENT_RED_SIZE;
			case 0x8213 -> FRAMEBUFFER_ATTACHMENT_GREEN_SIZE;
			case 0x8214 -> FRAMEBUFFER_ATTACHMENT_BLUE_SIZE;
			case 0x8215 -> FRAMEBUFFER_ATTACHMENT_ALPHA_SIZE;
			case 0x8216 -> FRAMEBUFFER_ATTACHMENT_DEPTH_SIZE;
			case 0x8217 -> FRAMEBUFFER_ATTACHMENT_STENCIL_SIZE;
			case 0x8cd0 -> FRAMEBUFFER_ATTACHMENT_OBJECT_TYPE;
			case 0x8cd1 -> FRAMEBUFFER_ATTACHMENT_OBJECT_NAME;
			case 0x8cd2 -> FRAMEBUFFER_ATTACHMENT_TEXTURE_LEVEL;
			case 0x8cd3 -> FRAMEBUFFER_ATTACHMENT_TEXTURE_CUBE_MAP_FACE;
			case 0x8cd4 -> FRAMEBUFFER_ATTACHMENT_TEXTURE_3D_ZOFFSET_EXT;
			case 0x8d6c -> FRAMEBUFFER_ATTACHMENT_TEXTURE_SAMPLES_EXT;
			case 0x8da7 -> FRAMEBUFFER_ATTACHMENT_LAYERED;
			case 0x913f -> FRAMEBUFFER_ATTACHMENT_TEXTURE_SCALE_IMG;
			case 0x9630 -> FRAMEBUFFER_ATTACHMENT_TEXTURE_NUM_VIEWS_OVR;
			case 0x9632 -> FRAMEBUFFER_ATTACHMENT_TEXTURE_BASE_VIEW_INDEX_OVR;
			default -> throw RawGLEnum.newUnrecognizedValueError(glEnum, "GLFramebufferAttachmentParameterName");
		};
	}
}