package dev.pfaff.glass.opengl.enums;

import java.util.List;

import dev.pfaff.glass.opengl.GLEnum;

import static java.util.FormatProcessor.FMT;

public enum GLFramebufferTarget implements GLEnum {
	READ_FRAMEBUFFER(0x8ca8),
	DRAW_FRAMEBUFFER(0x8ca9),
	FRAMEBUFFER(0x8d40);
	
	private final int glEnum;

	GLFramebufferTarget(int glEnum) {
		this.glEnum = glEnum;
	}

	public static final List<GLFramebufferTarget> VALUES = List.of(values());

	@Override
	public int glEnum() {
		return glEnum;
	}

	/**
	 * Returns the enum constant corresponding to the provided raw value.
	 *
	 * @throws IllegalArgumentException if the provided raw value does not exist in this enum group.
	 */
	public static GLFramebufferTarget fromGLEnum(int glEnum) {
		return switch (glEnum) {
			case 0x8ca8 -> READ_FRAMEBUFFER;
			case 0x8ca9 -> DRAW_FRAMEBUFFER;
			case 0x8d40 -> FRAMEBUFFER;
			default -> throw RawGLEnum.newUnrecognizedValueError(glEnum, "GLFramebufferTarget");
		};
	}
}