package dev.pfaff.glass.opengl.enums;

import java.util.List;

import dev.pfaff.glass.opengl.GLEnum;

import static java.util.FormatProcessor.FMT;

public enum GLGetFramebufferParameter implements GLEnum {
	DOUBLEBUFFER(0xc32),
	STEREO(0xc33),
	SAMPLE_BUFFERS(0x80a8),
	SAMPLES(0x80a9),
	IMPLEMENTATION_COLOR_READ_TYPE(0x8b9a),
	IMPLEMENTATION_COLOR_READ_FORMAT(0x8b9b),
	FRAMEBUFFER_DEFAULT_WIDTH(0x9310),
	FRAMEBUFFER_DEFAULT_HEIGHT(0x9311),
	FRAMEBUFFER_DEFAULT_LAYERS(0x9312),
	FRAMEBUFFER_DEFAULT_SAMPLES(0x9313),
	FRAMEBUFFER_DEFAULT_FIXED_SAMPLE_LOCATIONS(0x9314);
	
	private final int glEnum;

	GLGetFramebufferParameter(int glEnum) {
		this.glEnum = glEnum;
	}

	public static final List<GLGetFramebufferParameter> VALUES = List.of(values());

	@Override
	public int glEnum() {
		return glEnum;
	}

	/**
	 * Returns the enum constant corresponding to the provided raw value.
	 *
	 * @throws IllegalArgumentException if the provided raw value does not exist in this enum group.
	 */
	public static GLGetFramebufferParameter fromGLEnum(int glEnum) {
		return switch (glEnum) {
			case 0xc32 -> DOUBLEBUFFER;
			case 0xc33 -> STEREO;
			case 0x80a8 -> SAMPLE_BUFFERS;
			case 0x80a9 -> SAMPLES;
			case 0x8b9a -> IMPLEMENTATION_COLOR_READ_TYPE;
			case 0x8b9b -> IMPLEMENTATION_COLOR_READ_FORMAT;
			case 0x9310 -> FRAMEBUFFER_DEFAULT_WIDTH;
			case 0x9311 -> FRAMEBUFFER_DEFAULT_HEIGHT;
			case 0x9312 -> FRAMEBUFFER_DEFAULT_LAYERS;
			case 0x9313 -> FRAMEBUFFER_DEFAULT_SAMPLES;
			case 0x9314 -> FRAMEBUFFER_DEFAULT_FIXED_SAMPLE_LOCATIONS;
			default -> throw RawGLEnum.newUnrecognizedValueError(glEnum, "GLGetFramebufferParameter");
		};
	}
}