package dev.pfaff.glass.opengl.enums;

import java.util.List;

import dev.pfaff.glass.opengl.GLEnum;

import static java.util.FormatProcessor.FMT;

public enum GLGetTexBumpParameterATI implements GLEnum {
	BUMP_ROT_MATRIX_ATI(0x8775),
	BUMP_ROT_MATRIX_SIZE_ATI(0x8776),
	BUMP_NUM_TEX_UNITS_ATI(0x8777),
	BUMP_TEX_UNITS_ATI(0x8778);
	
	private final int glEnum;

	GLGetTexBumpParameterATI(int glEnum) {
		this.glEnum = glEnum;
	}

	public static final List<GLGetTexBumpParameterATI> VALUES = List.of(values());

	@Override
	public int glEnum() {
		return glEnum;
	}

	/**
	 * Returns the enum constant corresponding to the provided raw value.
	 *
	 * @throws IllegalArgumentException if the provided raw value does not exist in this enum group.
	 */
	public static GLGetTexBumpParameterATI fromGLEnum(int glEnum) {
		return switch (glEnum) {
			case 0x8775 -> BUMP_ROT_MATRIX_ATI;
			case 0x8776 -> BUMP_ROT_MATRIX_SIZE_ATI;
			case 0x8777 -> BUMP_NUM_TEX_UNITS_ATI;
			case 0x8778 -> BUMP_TEX_UNITS_ATI;
			default -> throw RawGLEnum.newUnrecognizedValueError(glEnum, "GLGetTexBumpParameterATI");
		};
	}
}