package dev.pfaff.glass.opengl.enums;

import java.util.List;

import dev.pfaff.glass.opengl.GLEnum;

import static java.util.FormatProcessor.FMT;

public enum GLHistogramTargetEXT implements GLEnum {
	HISTOGRAM(0x8024),
	PROXY_HISTOGRAM(0x8025);
	
	private final int glEnum;

	GLHistogramTargetEXT(int glEnum) {
		this.glEnum = glEnum;
	}

	public static final List<GLHistogramTargetEXT> VALUES = List.of(values());

	@Override
	public int glEnum() {
		return glEnum;
	}

	/**
	 * Returns the enum constant corresponding to the provided raw value.
	 *
	 * @throws IllegalArgumentException if the provided raw value does not exist in this enum group.
	 */
	public static GLHistogramTargetEXT fromGLEnum(int glEnum) {
		return switch (glEnum) {
			case 0x8024 -> HISTOGRAM;
			case 0x8025 -> PROXY_HISTOGRAM;
			default -> throw RawGLEnum.newUnrecognizedValueError(glEnum, "GLHistogramTargetEXT");
		};
	}
}