package dev.pfaff.glass.opengl.enums;

import java.util.List;

import dev.pfaff.glass.opengl.GLEnum;

import static java.util.FormatProcessor.FMT;

public enum GLIndexPointerType implements GLEnum {
	SHORT(0x1402),
	INT(0x1404),
	FLOAT(0x1406),
	DOUBLE(0x140a);
	
	private final int glEnum;

	GLIndexPointerType(int glEnum) {
		this.glEnum = glEnum;
	}

	public static final List<GLIndexPointerType> VALUES = List.of(values());

	@Override
	public int glEnum() {
		return glEnum;
	}

	/**
	 * Returns the enum constant corresponding to the provided raw value.
	 *
	 * @throws IllegalArgumentException if the provided raw value does not exist in this enum group.
	 */
	public static GLIndexPointerType fromGLEnum(int glEnum) {
		return switch (glEnum) {
			case 0x1402 -> SHORT;
			case 0x1404 -> INT;
			case 0x1406 -> FLOAT;
			case 0x140a -> DOUBLE;
			default -> throw RawGLEnum.newUnrecognizedValueError(glEnum, "GLIndexPointerType");
		};
	}
}