package dev.pfaff.glass.opengl.enums;

import java.util.List;

import dev.pfaff.glass.opengl.GLEnum;

import static java.util.FormatProcessor.FMT;

public enum GLLogicOp implements GLEnum {
	CLEAR(0x1500),
	AND(0x1501),
	AND_REVERSE(0x1502),
	COPY(0x1503),
	AND_INVERTED(0x1504),
	NOOP(0x1505),
	XOR(0x1506),
	OR(0x1507),
	NOR(0x1508),
	EQUIV(0x1509),
	INVERT(0x150a),
	OR_REVERSE(0x150b),
	COPY_INVERTED(0x150c),
	OR_INVERTED(0x150d),
	NAND(0x150e),
	SET(0x150f);
	
	private final int glEnum;

	GLLogicOp(int glEnum) {
		this.glEnum = glEnum;
	}

	public static final List<GLLogicOp> VALUES = List.of(values());

	@Override
	public int glEnum() {
		return glEnum;
	}

	/**
	 * Returns the enum constant corresponding to the provided raw value.
	 *
	 * @throws IllegalArgumentException if the provided raw value does not exist in this enum group.
	 */
	public static GLLogicOp fromGLEnum(int glEnum) {
		return switch (glEnum) {
			case 0x1500 -> CLEAR;
			case 0x1501 -> AND;
			case 0x1502 -> AND_REVERSE;
			case 0x1503 -> COPY;
			case 0x1504 -> AND_INVERTED;
			case 0x1505 -> NOOP;
			case 0x1506 -> XOR;
			case 0x1507 -> OR;
			case 0x1508 -> NOR;
			case 0x1509 -> EQUIV;
			case 0x150a -> INVERT;
			case 0x150b -> OR_REVERSE;
			case 0x150c -> COPY_INVERTED;
			case 0x150d -> OR_INVERTED;
			case 0x150e -> NAND;
			case 0x150f -> SET;
			default -> throw RawGLEnum.newUnrecognizedValueError(glEnum, "GLLogicOp");
		};
	}
}