package dev.pfaff.glass.opengl.enums;

import java.util.List;

import dev.pfaff.glass.opengl.GLEnum;

import static java.util.FormatProcessor.FMT;

public enum GLMapAttribParameterNV implements GLEnum {
	MAP_ATTRIB_U_ORDER_NV(0x86c3),
	MAP_ATTRIB_V_ORDER_NV(0x86c4);
	
	private final int glEnum;

	GLMapAttribParameterNV(int glEnum) {
		this.glEnum = glEnum;
	}

	public static final List<GLMapAttribParameterNV> VALUES = List.of(values());

	@Override
	public int glEnum() {
		return glEnum;
	}

	/**
	 * Returns the enum constant corresponding to the provided raw value.
	 *
	 * @throws IllegalArgumentException if the provided raw value does not exist in this enum group.
	 */
	public static GLMapAttribParameterNV fromGLEnum(int glEnum) {
		return switch (glEnum) {
			case 0x86c3 -> MAP_ATTRIB_U_ORDER_NV;
			case 0x86c4 -> MAP_ATTRIB_V_ORDER_NV;
			default -> throw RawGLEnum.newUnrecognizedValueError(glEnum, "GLMapAttribParameterNV");
		};
	}
}