package dev.pfaff.glass.opengl.enums;

import java.util.List;

import dev.pfaff.glass.opengl.GLEnum;

import static java.util.FormatProcessor.FMT;

public enum GLMinmaxTargetEXT implements GLEnum {
	MINMAX(0x802e);
	
	private final int glEnum;

	GLMinmaxTargetEXT(int glEnum) {
		this.glEnum = glEnum;
	}

	public static final List<GLMinmaxTargetEXT> VALUES = List.of(values());

	@Override
	public int glEnum() {
		return glEnum;
	}

	/**
	 * Returns the enum constant corresponding to the provided raw value.
	 *
	 * @throws IllegalArgumentException if the provided raw value does not exist in this enum group.
	 */
	public static GLMinmaxTargetEXT fromGLEnum(int glEnum) {
		return switch (glEnum) {
			case 0x802e -> MINMAX;
			default -> throw RawGLEnum.newUnrecognizedValueError(glEnum, "GLMinmaxTargetEXT");
		};
	}
}