package dev.pfaff.glass.opengl.enums;

import java.util.List;

import dev.pfaff.glass.opengl.GLEnum;

import static java.util.FormatProcessor.FMT;

public enum GLPathFontStyle implements GLEnum {
	NONE(0x0),
	BOLD_BIT_NV(0x1),
	ITALIC_BIT_NV(0x2);
	
	private final int glEnum;

	GLPathFontStyle(int glEnum) {
		this.glEnum = glEnum;
	}

	public static final List<GLPathFontStyle> VALUES = List.of(values());

	@Override
	public int glEnum() {
		return glEnum;
	}

	/**
	 * Returns the enum constant corresponding to the provided raw value.
	 *
	 * @throws IllegalArgumentException if the provided raw value does not exist in this enum group.
	 */
	public static GLPathFontStyle fromGLEnum(int glEnum) {
		return switch (glEnum) {
			case 0x0 -> NONE;
			case 0x1 -> BOLD_BIT_NV;
			case 0x2 -> ITALIC_BIT_NV;
			default -> throw RawGLEnum.newUnrecognizedValueError(glEnum, "GLPathFontStyle");
		};
	}
}