package dev.pfaff.glass.opengl.enums;

import java.util.List;

import dev.pfaff.glass.opengl.GLEnum;

import static java.util.FormatProcessor.FMT;

public enum GLPathGenMode implements GLEnum {
	NONE(0x0),
	EYE_LINEAR(0x2400),
	OBJECT_LINEAR(0x2401),
	CONSTANT(0x8576),
	PATH_OBJECT_BOUNDING_BOX_NV(0x908a);
	
	private final int glEnum;

	GLPathGenMode(int glEnum) {
		this.glEnum = glEnum;
	}

	public static final List<GLPathGenMode> VALUES = List.of(values());

	@Override
	public int glEnum() {
		return glEnum;
	}

	/**
	 * Returns the enum constant corresponding to the provided raw value.
	 *
	 * @throws IllegalArgumentException if the provided raw value does not exist in this enum group.
	 */
	public static GLPathGenMode fromGLEnum(int glEnum) {
		return switch (glEnum) {
			case 0x0 -> NONE;
			case 0x2400 -> EYE_LINEAR;
			case 0x2401 -> OBJECT_LINEAR;
			case 0x8576 -> CONSTANT;
			case 0x908a -> PATH_OBJECT_BOUNDING_BOX_NV;
			default -> throw RawGLEnum.newUnrecognizedValueError(glEnum, "GLPathGenMode");
		};
	}
}