package dev.pfaff.glass.opengl.enums;

import java.util.List;

import dev.pfaff.glass.opengl.GLEnum;

import static java.util.FormatProcessor.FMT;

public enum GLPixelTransformPNameEXT implements GLEnum {
	PIXEL_MAG_FILTER_EXT(0x8331),
	PIXEL_MIN_FILTER_EXT(0x8332),
	PIXEL_CUBIC_WEIGHT_EXT(0x8333);
	
	private final int glEnum;

	GLPixelTransformPNameEXT(int glEnum) {
		this.glEnum = glEnum;
	}

	public static final List<GLPixelTransformPNameEXT> VALUES = List.of(values());

	@Override
	public int glEnum() {
		return glEnum;
	}

	/**
	 * Returns the enum constant corresponding to the provided raw value.
	 *
	 * @throws IllegalArgumentException if the provided raw value does not exist in this enum group.
	 */
	public static GLPixelTransformPNameEXT fromGLEnum(int glEnum) {
		return switch (glEnum) {
			case 0x8331 -> PIXEL_MAG_FILTER_EXT;
			case 0x8332 -> PIXEL_MIN_FILTER_EXT;
			case 0x8333 -> PIXEL_CUBIC_WEIGHT_EXT;
			default -> throw RawGLEnum.newUnrecognizedValueError(glEnum, "GLPixelTransformPNameEXT");
		};
	}
}