package dev.pfaff.glass.opengl.enums;

import java.util.List;

import dev.pfaff.glass.opengl.GLEnum;

import static java.util.FormatProcessor.FMT;

public enum GLPointParameterNameARB implements GLEnum {
	POINT_SIZE_MIN(0x8126),
	POINT_SIZE_MAX(0x8127),
	POINT_FADE_THRESHOLD_SIZE(0x8128),
	DISTANCE_ATTENUATION_EXT(0x8129);
	
	private final int glEnum;

	GLPointParameterNameARB(int glEnum) {
		this.glEnum = glEnum;
	}

	public static final List<GLPointParameterNameARB> VALUES = List.of(values());

	@Override
	public int glEnum() {
		return glEnum;
	}

	/**
	 * Returns the enum constant corresponding to the provided raw value.
	 *
	 * @throws IllegalArgumentException if the provided raw value does not exist in this enum group.
	 */
	public static GLPointParameterNameARB fromGLEnum(int glEnum) {
		return switch (glEnum) {
			case 0x8126 -> POINT_SIZE_MIN;
			case 0x8127 -> POINT_SIZE_MAX;
			case 0x8128 -> POINT_FADE_THRESHOLD_SIZE;
			case 0x8129 -> DISTANCE_ATTENUATION_EXT;
			default -> throw RawGLEnum.newUnrecognizedValueError(glEnum, "GLPointParameterNameARB");
		};
	}
}