package dev.pfaff.glass.opengl.enums;

import java.util.List;

import dev.pfaff.glass.opengl.GLEnum;

import static java.util.FormatProcessor.FMT;

public enum GLProgramStringProperty implements GLEnum {
	PROGRAM_STRING_ARB(0x8628);
	
	private final int glEnum;

	GLProgramStringProperty(int glEnum) {
		this.glEnum = glEnum;
	}

	public static final List<GLProgramStringProperty> VALUES = List.of(values());

	@Override
	public int glEnum() {
		return glEnum;
	}

	/**
	 * Returns the enum constant corresponding to the provided raw value.
	 *
	 * @throws IllegalArgumentException if the provided raw value does not exist in this enum group.
	 */
	public static GLProgramStringProperty fromGLEnum(int glEnum) {
		return switch (glEnum) {
			case 0x8628 -> PROGRAM_STRING_ARB;
			default -> throw RawGLEnum.newUnrecognizedValueError(glEnum, "GLProgramStringProperty");
		};
	}
}