package dev.pfaff.glass.opengl.enums;

import java.util.List;

import dev.pfaff.glass.opengl.GLEnum;

import static java.util.FormatProcessor.FMT;

public enum GLScalarType implements GLEnum {
	UNSIGNED_BYTE(0x1401),
	UNSIGNED_SHORT(0x1403),
	UNSIGNED_INT(0x1405);
	
	private final int glEnum;

	GLScalarType(int glEnum) {
		this.glEnum = glEnum;
	}

	public static final List<GLScalarType> VALUES = List.of(values());

	@Override
	public int glEnum() {
		return glEnum;
	}

	/**
	 * Returns the enum constant corresponding to the provided raw value.
	 *
	 * @throws IllegalArgumentException if the provided raw value does not exist in this enum group.
	 */
	public static GLScalarType fromGLEnum(int glEnum) {
		return switch (glEnum) {
			case 0x1401 -> UNSIGNED_BYTE;
			case 0x1403 -> UNSIGNED_SHORT;
			case 0x1405 -> UNSIGNED_INT;
			default -> throw RawGLEnum.newUnrecognizedValueError(glEnum, "GLScalarType");
		};
	}
}