package dev.pfaff.glass.opengl.enums;

import java.util.List;

import dev.pfaff.glass.opengl.GLEnum;

import static java.util.FormatProcessor.FMT;

public enum GLShadingModel implements GLEnum {
	FLAT(0x1d00),
	SMOOTH(0x1d01);
	
	private final int glEnum;

	GLShadingModel(int glEnum) {
		this.glEnum = glEnum;
	}

	public static final List<GLShadingModel> VALUES = List.of(values());

	@Override
	public int glEnum() {
		return glEnum;
	}

	/**
	 * Returns the enum constant corresponding to the provided raw value.
	 *
	 * @throws IllegalArgumentException if the provided raw value does not exist in this enum group.
	 */
	public static GLShadingModel fromGLEnum(int glEnum) {
		return switch (glEnum) {
			case 0x1d00 -> FLAT;
			case 0x1d01 -> SMOOTH;
			default -> throw RawGLEnum.newUnrecognizedValueError(glEnum, "GLShadingModel");
		};
	}
}