package dev.pfaff.glass.opengl.enums;

import java.util.List;

import dev.pfaff.glass.opengl.GLEnum;

import static java.util.FormatProcessor.FMT;

public enum GLSpriteModeSGIX implements GLEnum {
	SPRITE_AXIAL_SGIX(0x814c),
	SPRITE_OBJECT_ALIGNED_SGIX(0x814d),
	SPRITE_EYE_ALIGNED_SGIX(0x814e);
	
	private final int glEnum;

	GLSpriteModeSGIX(int glEnum) {
		this.glEnum = glEnum;
	}

	public static final List<GLSpriteModeSGIX> VALUES = List.of(values());

	@Override
	public int glEnum() {
		return glEnum;
	}

	/**
	 * Returns the enum constant corresponding to the provided raw value.
	 *
	 * @throws IllegalArgumentException if the provided raw value does not exist in this enum group.
	 */
	public static GLSpriteModeSGIX fromGLEnum(int glEnum) {
		return switch (glEnum) {
			case 0x814c -> SPRITE_AXIAL_SGIX;
			case 0x814d -> SPRITE_OBJECT_ALIGNED_SGIX;
			case 0x814e -> SPRITE_EYE_ALIGNED_SGIX;
			default -> throw RawGLEnum.newUnrecognizedValueError(glEnum, "GLSpriteModeSGIX");
		};
	}
}