package dev.pfaff.glass.opengl.enums;

import java.util.List;

import dev.pfaff.glass.opengl.GLEnum;

import static java.util.FormatProcessor.FMT;

public enum GLStringName implements GLEnum {
	VENDOR(0x1f00),
	RENDERER(0x1f01),
	VERSION(0x1f02),
	EXTENSIONS(0x1f03),
	SHADING_LANGUAGE_VERSION(0x8b8c);
	
	private final int glEnum;

	GLStringName(int glEnum) {
		this.glEnum = glEnum;
	}

	public static final List<GLStringName> VALUES = List.of(values());

	@Override
	public int glEnum() {
		return glEnum;
	}

	/**
	 * Returns the enum constant corresponding to the provided raw value.
	 *
	 * @throws IllegalArgumentException if the provided raw value does not exist in this enum group.
	 */
	public static GLStringName fromGLEnum(int glEnum) {
		return switch (glEnum) {
			case 0x1f00 -> VENDOR;
			case 0x1f01 -> RENDERER;
			case 0x1f02 -> VERSION;
			case 0x1f03 -> EXTENSIONS;
			case 0x8b8c -> SHADING_LANGUAGE_VERSION;
			default -> throw RawGLEnum.newUnrecognizedValueError(glEnum, "GLStringName");
		};
	}
}