package dev.pfaff.glass.opengl.enums;

import java.util.List;

import dev.pfaff.glass.opengl.GLEnum;

import static java.util.FormatProcessor.FMT;

public enum GLSubroutineParameterName implements GLEnum {
	UNIFORM_SIZE(0x8a38),
	UNIFORM_NAME_LENGTH(0x8a39),
	NUM_COMPATIBLE_SUBROUTINES(0x8e4a),
	COMPATIBLE_SUBROUTINES(0x8e4b);
	
	private final int glEnum;

	GLSubroutineParameterName(int glEnum) {
		this.glEnum = glEnum;
	}

	public static final List<GLSubroutineParameterName> VALUES = List.of(values());

	@Override
	public int glEnum() {
		return glEnum;
	}

	/**
	 * Returns the enum constant corresponding to the provided raw value.
	 *
	 * @throws IllegalArgumentException if the provided raw value does not exist in this enum group.
	 */
	public static GLSubroutineParameterName fromGLEnum(int glEnum) {
		return switch (glEnum) {
			case 0x8a38 -> UNIFORM_SIZE;
			case 0x8a39 -> UNIFORM_NAME_LENGTH;
			case 0x8e4a -> NUM_COMPATIBLE_SUBROUTINES;
			case 0x8e4b -> COMPATIBLE_SUBROUTINES;
			default -> throw RawGLEnum.newUnrecognizedValueError(glEnum, "GLSubroutineParameterName");
		};
	}
}