package dev.pfaff.glass.opengl.enums;

import java.util.List;

import dev.pfaff.glass.opengl.GLEnum;

import static java.util.FormatProcessor.FMT;

public enum GLSyncObjectMask implements GLEnum {
	SYNC_FLUSH_COMMANDS_BIT(0x1);
	
	private final int glEnum;

	GLSyncObjectMask(int glEnum) {
		this.glEnum = glEnum;
	}

	public static final List<GLSyncObjectMask> VALUES = List.of(values());

	@Override
	public int glEnum() {
		return glEnum;
	}

	/**
	 * Returns the enum constant corresponding to the provided raw value.
	 *
	 * @throws IllegalArgumentException if the provided raw value does not exist in this enum group.
	 */
	public static GLSyncObjectMask fromGLEnum(int glEnum) {
		return switch (glEnum) {
			case 0x1 -> SYNC_FLUSH_COMMANDS_BIT;
			default -> throw RawGLEnum.newUnrecognizedValueError(glEnum, "GLSyncObjectMask");
		};
	}
}