package dev.pfaff.glass.opengl.enums;

import java.util.List;

import dev.pfaff.glass.opengl.GLEnum;

import static java.util.FormatProcessor.FMT;

public enum GLTextureCompareMode implements GLEnum {
	NONE(0x0),
	COMPARE_R_TO_TEXTURE(0x884e);
	
	private final int glEnum;

	GLTextureCompareMode(int glEnum) {
		this.glEnum = glEnum;
	}

	public static final List<GLTextureCompareMode> VALUES = List.of(values());

	@Override
	public int glEnum() {
		return glEnum;
	}

	/**
	 * Returns the enum constant corresponding to the provided raw value.
	 *
	 * @throws IllegalArgumentException if the provided raw value does not exist in this enum group.
	 */
	public static GLTextureCompareMode fromGLEnum(int glEnum) {
		return switch (glEnum) {
			case 0x0 -> NONE;
			case 0x884e -> COMPARE_R_TO_TEXTURE;
			default -> throw RawGLEnum.newUnrecognizedValueError(glEnum, "GLTextureCompareMode");
		};
	}
}