package dev.pfaff.glass.opengl.enums;

import java.util.List;

import dev.pfaff.glass.opengl.GLEnum;

import static java.util.FormatProcessor.FMT;

public enum GLTextureEnvTarget implements GLEnum {
	TEXTURE_ENV(0x2300),
	TEXTURE_FILTER_CONTROL(0x8500),
	POINT_SPRITE(0x8861);
	
	private final int glEnum;

	GLTextureEnvTarget(int glEnum) {
		this.glEnum = glEnum;
	}

	public static final List<GLTextureEnvTarget> VALUES = List.of(values());

	@Override
	public int glEnum() {
		return glEnum;
	}

	/**
	 * Returns the enum constant corresponding to the provided raw value.
	 *
	 * @throws IllegalArgumentException if the provided raw value does not exist in this enum group.
	 */
	public static GLTextureEnvTarget fromGLEnum(int glEnum) {
		return switch (glEnum) {
			case 0x2300 -> TEXTURE_ENV;
			case 0x8500 -> TEXTURE_FILTER_CONTROL;
			case 0x8861 -> POINT_SPRITE;
			default -> throw RawGLEnum.newUnrecognizedValueError(glEnum, "GLTextureEnvTarget");
		};
	}
}