package dev.pfaff.glass.opengl.enums;

import java.util.List;

import dev.pfaff.glass.opengl.GLEnum;

import static java.util.FormatProcessor.FMT;

public enum GLTriangleListSUN implements GLEnum {
	RESTART_SUN(0x1),
	REPLACE_MIDDLE_SUN(0x2),
	REPLACE_OLDEST_SUN(0x3);
	
	private final int glEnum;

	GLTriangleListSUN(int glEnum) {
		this.glEnum = glEnum;
	}

	public static final List<GLTriangleListSUN> VALUES = List.of(values());

	@Override
	public int glEnum() {
		return glEnum;
	}

	/**
	 * Returns the enum constant corresponding to the provided raw value.
	 *
	 * @throws IllegalArgumentException if the provided raw value does not exist in this enum group.
	 */
	public static GLTriangleListSUN fromGLEnum(int glEnum) {
		return switch (glEnum) {
			case 0x1 -> RESTART_SUN;
			case 0x2 -> REPLACE_MIDDLE_SUN;
			case 0x3 -> REPLACE_OLDEST_SUN;
			default -> throw RawGLEnum.newUnrecognizedValueError(glEnum, "GLTriangleListSUN");
		};
	}
}