package dev.pfaff.glass.opengl.enums;

import java.util.List;

import dev.pfaff.glass.opengl.GLEnum;

import static java.util.FormatProcessor.FMT;

public enum GLVertexArrayPName implements GLEnum {
	VERTEX_ATTRIB_RELATIVE_OFFSET(0x82d5),
	VERTEX_ATTRIB_ARRAY_ENABLED(0x8622),
	VERTEX_ATTRIB_ARRAY_SIZE(0x8623),
	VERTEX_ATTRIB_ARRAY_STRIDE(0x8624),
	VERTEX_ATTRIB_ARRAY_TYPE(0x8625),
	VERTEX_ATTRIB_ARRAY_LONG(0x874e),
	VERTEX_ATTRIB_ARRAY_NORMALIZED(0x886a),
	VERTEX_ATTRIB_ARRAY_INTEGER(0x88fd),
	VERTEX_ATTRIB_ARRAY_DIVISOR(0x88fe);
	
	private final int glEnum;

	GLVertexArrayPName(int glEnum) {
		this.glEnum = glEnum;
	}

	public static final List<GLVertexArrayPName> VALUES = List.of(values());

	@Override
	public int glEnum() {
		return glEnum;
	}

	/**
	 * Returns the enum constant corresponding to the provided raw value.
	 *
	 * @throws IllegalArgumentException if the provided raw value does not exist in this enum group.
	 */
	public static GLVertexArrayPName fromGLEnum(int glEnum) {
		return switch (glEnum) {
			case 0x82d5 -> VERTEX_ATTRIB_RELATIVE_OFFSET;
			case 0x8622 -> VERTEX_ATTRIB_ARRAY_ENABLED;
			case 0x8623 -> VERTEX_ATTRIB_ARRAY_SIZE;
			case 0x8624 -> VERTEX_ATTRIB_ARRAY_STRIDE;
			case 0x8625 -> VERTEX_ATTRIB_ARRAY_TYPE;
			case 0x874e -> VERTEX_ATTRIB_ARRAY_LONG;
			case 0x886a -> VERTEX_ATTRIB_ARRAY_NORMALIZED;
			case 0x88fd -> VERTEX_ATTRIB_ARRAY_INTEGER;
			case 0x88fe -> VERTEX_ATTRIB_ARRAY_DIVISOR;
			default -> throw RawGLEnum.newUnrecognizedValueError(glEnum, "GLVertexArrayPName");
		};
	}
}