package dev.pfaff.glass.opengl.enums;

import java.util.List;

import dev.pfaff.glass.opengl.GLEnum;

import static java.util.FormatProcessor.FMT;

public enum GLVertexAttribEnumNV implements GLEnum {
	PROGRAM_PARAMETER_NV(0x8644);
	
	private final int glEnum;

	GLVertexAttribEnumNV(int glEnum) {
		this.glEnum = glEnum;
	}

	public static final List<GLVertexAttribEnumNV> VALUES = List.of(values());

	@Override
	public int glEnum() {
		return glEnum;
	}

	/**
	 * Returns the enum constant corresponding to the provided raw value.
	 *
	 * @throws IllegalArgumentException if the provided raw value does not exist in this enum group.
	 */
	public static GLVertexAttribEnumNV fromGLEnum(int glEnum) {
		return switch (glEnum) {
			case 0x8644 -> PROGRAM_PARAMETER_NV;
			default -> throw RawGLEnum.newUnrecognizedValueError(glEnum, "GLVertexAttribEnumNV");
		};
	}
}