package dev.pfaff.glass.opengl.enums;

import java.util.List;

import dev.pfaff.glass.opengl.GLEnum;

import static java.util.FormatProcessor.FMT;

public enum GLVertexAttribIType implements GLEnum, IGLVertexAttribPointerType {
	BYTE(0x1400),
	UNSIGNED_BYTE(0x1401),
	SHORT(0x1402),
	UNSIGNED_SHORT(0x1403),
	INT(0x1404),
	UNSIGNED_INT(0x1405);
	
	private final int glEnum;

	GLVertexAttribIType(int glEnum) {
		this.glEnum = glEnum;
	}

	public static final List<GLVertexAttribIType> VALUES = List.of(values());

	@Override
	public int glEnum() {
		return glEnum;
	}

	/**
	 * Returns the enum constant corresponding to the provided raw value.
	 *
	 * @throws IllegalArgumentException if the provided raw value does not exist in this enum group.
	 */
	public static GLVertexAttribIType fromGLEnum(int glEnum) {
		return switch (glEnum) {
			case 0x1400 -> BYTE;
			case 0x1401 -> UNSIGNED_BYTE;
			case 0x1402 -> SHORT;
			case 0x1403 -> UNSIGNED_SHORT;
			case 0x1404 -> INT;
			case 0x1405 -> UNSIGNED_INT;
			default -> throw RawGLEnum.newUnrecognizedValueError(glEnum, "GLVertexAttribIType");
		};
	}

	@Override
	public java.lang.foreign.ValueLayout layout() {
		return switch (this) {
			case BYTE -> java.lang.foreign.ValueLayout.JAVA_BYTE;
			case UNSIGNED_BYTE -> java.lang.foreign.ValueLayout.JAVA_BYTE;
			case SHORT -> java.lang.foreign.ValueLayout.JAVA_SHORT;
			case UNSIGNED_SHORT -> java.lang.foreign.ValueLayout.JAVA_SHORT;
			case INT -> java.lang.foreign.ValueLayout.JAVA_INT;
			case UNSIGNED_INT -> java.lang.foreign.ValueLayout.JAVA_INT;
		};
	}
}