package dev.pfaff.glass.opengl.enums;

import java.util.List;

import dev.pfaff.glass.opengl.GLEnum;

import static java.util.FormatProcessor.FMT;

public enum GLVertexShaderCoordOutEXT implements GLEnum {
	X_EXT(0x87d5),
	Y_EXT(0x87d6),
	Z_EXT(0x87d7),
	W_EXT(0x87d8),
	NEGATIVE_X_EXT(0x87d9),
	NEGATIVE_Y_EXT(0x87da),
	NEGATIVE_Z_EXT(0x87db),
	NEGATIVE_W_EXT(0x87dc),
	ZERO_EXT(0x87dd),
	ONE_EXT(0x87de),
	NEGATIVE_ONE_EXT(0x87df);
	
	private final int glEnum;

	GLVertexShaderCoordOutEXT(int glEnum) {
		this.glEnum = glEnum;
	}

	public static final List<GLVertexShaderCoordOutEXT> VALUES = List.of(values());

	@Override
	public int glEnum() {
		return glEnum;
	}

	/**
	 * Returns the enum constant corresponding to the provided raw value.
	 *
	 * @throws IllegalArgumentException if the provided raw value does not exist in this enum group.
	 */
	public static GLVertexShaderCoordOutEXT fromGLEnum(int glEnum) {
		return switch (glEnum) {
			case 0x87d5 -> X_EXT;
			case 0x87d6 -> Y_EXT;
			case 0x87d7 -> Z_EXT;
			case 0x87d8 -> W_EXT;
			case 0x87d9 -> NEGATIVE_X_EXT;
			case 0x87da -> NEGATIVE_Y_EXT;
			case 0x87db -> NEGATIVE_Z_EXT;
			case 0x87dc -> NEGATIVE_W_EXT;
			case 0x87dd -> ZERO_EXT;
			case 0x87de -> ONE_EXT;
			case 0x87df -> NEGATIVE_ONE_EXT;
			default -> throw RawGLEnum.newUnrecognizedValueError(glEnum, "GLVertexShaderCoordOutEXT");
		};
	}
}