package dev.pfaff.glass.opengl.enums;

import java.util.List;

import dev.pfaff.glass.opengl.GLEnum;

import static java.util.FormatProcessor.FMT;

public enum GLVertexShaderOpEXT implements GLEnum {
	OP_INDEX_EXT(0x8782),
	OP_NEGATE_EXT(0x8783),
	OP_DOT3_EXT(0x8784),
	OP_DOT4_EXT(0x8785),
	OP_MUL_EXT(0x8786),
	OP_ADD_EXT(0x8787),
	OP_MADD_EXT(0x8788),
	OP_FRAC_EXT(0x8789),
	OP_MAX_EXT(0x878a),
	OP_MIN_EXT(0x878b),
	OP_SET_GE_EXT(0x878c),
	OP_SET_LT_EXT(0x878d),
	OP_CLAMP_EXT(0x878e),
	OP_FLOOR_EXT(0x878f),
	OP_ROUND_EXT(0x8790),
	OP_EXP_BASE_2_EXT(0x8791),
	OP_LOG_BASE_2_EXT(0x8792),
	OP_POWER_EXT(0x8793),
	OP_RECIP_EXT(0x8794),
	OP_RECIP_SQRT_EXT(0x8795),
	OP_SUB_EXT(0x8796),
	OP_CROSS_PRODUCT_EXT(0x8797),
	OP_MULTIPLY_MATRIX_EXT(0x8798),
	OP_MOV_EXT(0x8799);
	
	private final int glEnum;

	GLVertexShaderOpEXT(int glEnum) {
		this.glEnum = glEnum;
	}

	public static final List<GLVertexShaderOpEXT> VALUES = List.of(values());

	@Override
	public int glEnum() {
		return glEnum;
	}

	/**
	 * Returns the enum constant corresponding to the provided raw value.
	 *
	 * @throws IllegalArgumentException if the provided raw value does not exist in this enum group.
	 */
	public static GLVertexShaderOpEXT fromGLEnum(int glEnum) {
		return switch (glEnum) {
			case 0x8782 -> OP_INDEX_EXT;
			case 0x8783 -> OP_NEGATE_EXT;
			case 0x8784 -> OP_DOT3_EXT;
			case 0x8785 -> OP_DOT4_EXT;
			case 0x8786 -> OP_MUL_EXT;
			case 0x8787 -> OP_ADD_EXT;
			case 0x8788 -> OP_MADD_EXT;
			case 0x8789 -> OP_FRAC_EXT;
			case 0x878a -> OP_MAX_EXT;
			case 0x878b -> OP_MIN_EXT;
			case 0x878c -> OP_SET_GE_EXT;
			case 0x878d -> OP_SET_LT_EXT;
			case 0x878e -> OP_CLAMP_EXT;
			case 0x878f -> OP_FLOOR_EXT;
			case 0x8790 -> OP_ROUND_EXT;
			case 0x8791 -> OP_EXP_BASE_2_EXT;
			case 0x8792 -> OP_LOG_BASE_2_EXT;
			case 0x8793 -> OP_POWER_EXT;
			case 0x8794 -> OP_RECIP_EXT;
			case 0x8795 -> OP_RECIP_SQRT_EXT;
			case 0x8796 -> OP_SUB_EXT;
			case 0x8797 -> OP_CROSS_PRODUCT_EXT;
			case 0x8798 -> OP_MULTIPLY_MATRIX_EXT;
			case 0x8799 -> OP_MOV_EXT;
			default -> throw RawGLEnum.newUnrecognizedValueError(glEnum, "GLVertexShaderOpEXT");
		};
	}
}