package dev.pfaff.glass.opengl.enums;

import java.util.List;

import dev.pfaff.glass.opengl.GLEnum;

import static java.util.FormatProcessor.FMT;

public enum GLVertexShaderParameterEXT implements GLEnum {
	CURRENT_VERTEX_EXT(0x87e2),
	MVP_MATRIX_EXT(0x87e3);
	
	private final int glEnum;

	GLVertexShaderParameterEXT(int glEnum) {
		this.glEnum = glEnum;
	}

	public static final List<GLVertexShaderParameterEXT> VALUES = List.of(values());

	@Override
	public int glEnum() {
		return glEnum;
	}

	/**
	 * Returns the enum constant corresponding to the provided raw value.
	 *
	 * @throws IllegalArgumentException if the provided raw value does not exist in this enum group.
	 */
	public static GLVertexShaderParameterEXT fromGLEnum(int glEnum) {
		return switch (glEnum) {
			case 0x87e2 -> CURRENT_VERTEX_EXT;
			case 0x87e3 -> MVP_MATRIX_EXT;
			default -> throw RawGLEnum.newUnrecognizedValueError(glEnum, "GLVertexShaderParameterEXT");
		};
	}
}