package dev.pfaff.glass.pthread;

import java.lang.foreign.Arena;
import java.lang.foreign.FunctionDescriptor;
import java.lang.foreign.Linker;
import java.lang.foreign.SymbolLookup;
import java.lang.invoke.MethodHandle;

import static java.lang.foreign.ValueLayout.JAVA_INT;

public final class PThread {
	private static final MethodHandle MH_pthread_threadid_np;

	static {
		var lookup = SymbolLookup.libraryLookup("/usr/lib/system/libsystem_pthread.dylib", Arena.ofAuto());
		var linker = Linker.nativeLinker();
		MH_pthread_threadid_np = linker.downcallHandle(lookup.find("pthread_threadid_np").get(),
				FunctionDescriptor.of(JAVA_INT));
	}

	public static int pthread_threadid_np() {
		try {
			return (int) MH_pthread_threadid_np.invokeExact();
		} catch (Throwable e) {
			throw new RuntimeException(e);
		}
	}
}
